<?php
include "NanoleafAuroraData.php";

// Aurora turn on/off - e.g. state=on/off - if off is used all other commands will be ignored

if (isset ( $_REQUEST ['state'] )) {
	$state = $_REQUEST ['state'];
	$url = 'http://' . $ip . $api_url . $api_key . '/state';
	if ($state == "off") {
		$command = '{"on" : {"value":false}}'; // ab Firmware 1.5.0
		// $command = '{"on":false}'; // bis Firmware 1.4.39
		callurl($url,$command);
		exit();
	} elseif ($state == "on") {
		$command = '{"on" : {"value":true}}'; // ab Firmware 1.5.0
		// $command = '{"on":true}'; // bis Firmware 1.4.39
		callurl($url,$command);
	}
}

// Aurora scene recall - e.g. scene=Forest

if (isset ( $_REQUEST ['scene'] )) {
	$scene = $_REQUEST ['scene'];
		$url = 'http://' . $ip . $api_url . $api_key . '/effects';
		$command = '{"select":"' . $scene .'"}';
		callurl($url,$command);
}

// Aurora light bulb Kelvin - e.g. k=2500

if (isset ( $_REQUEST ['k'] )) {
	$k = $_REQUEST ['k'];
		$url = 'http://' . $ip . $api_url . $api_key . '/state/ct';
		$command = '{"ct":{"value":' . $k . '}}';
		callurl($url,$command);
}

// Aurora brightness - e.g. brightness=0 (0-100), brightness=+10, brightness=-20

if (isset ( $_REQUEST ['brightness'] )) {
	$brightness = $_REQUEST ['brightness'];
	
	$brightness = urlencode($brightness);
    $brightness = str_replace("+", "%2B",$brightness);
    $brightness = urldecode($brightness);

	if (strlen(strstr($brightness,"-"))>0) {
		$command = '{"brightness":{"increment":' . $brightness . '}}'; // ab Firmware 1.5.0
	} else if (strlen(strstr($brightness,"+"))>0) {
		$brightness = intval($brightness);
		$command = '{"brightness":{"increment":' . $brightness . '}}'; // ab Firmware 1.5.0
	} else {
		$command = '{"brightness":{"value":' . $brightness . '}}'; // ab Firmware 1.5.0
		// $command = '{"brightness":' . $brightness .'}'; // bis Firmware 1.4.39
	}

	$url = 'http://' . $ip . $api_url . $api_key . '/state';
	callurl($url,$command);
}

// Aurora alarm
// Colors - HSB color space -> http://www.workwithcolor.com/color-converter-01.htm

$red = '{"hue":0,"saturation":100,"brightness":100}';
$blue = '{"hue":240,"saturation":100,"brightness":100}';
$green = '{"hue":120,"saturation":100,"brightness":50}';
$yellow = '{"hue":60,"saturation":100,"brightness":100}';
$white = '{"hue":0,"saturation":0,"brightness":100}';
$cyan = '{"hue":180,"saturation":100,"brightness":100}';
$magenta = '{"hue":300,"saturation":100,"brightness":100}';

$color = $red; // standard

if (isset ( $_REQUEST ['alarm'] )) {
	$alarm = $_REQUEST ['alarm'];

	switch ($alarm) {
	    case "red": $color = $red; break;
	    case "blue": $color = $blue; break;
	    case "green": $color = $green; break;
		case "yellow": $color = $yellow; break;
	    case "white": $color = $white; break;
	    case "cyan": $color = $cyan; break;
		case "magenta": $color = $magenta; break;
	}
		if (isset ( $_REQUEST ['duration'] )) {
			$duration = $_REQUEST ['duration'];
		} else {
			$duration = 5;
		}

		if (isset ( $_REQUEST ['blink'] )) {
			$command = '{  
						    "write":{  
						        "command":"displayTemp",
						        "duration":'. $duration .',
						        "animType":"fade",
						        "palette":[  
						            '. $color .',
						            {  
						                "hue":0,
						                "saturation":0,
						                "brightness":0
						            }
						        ],
						        "transTime":{  
						            "maxValue":2,
						            "minValue":4
						        },
						        "delayTime":{  
						            "minValue":4,
						            "maxValue":2
						        },
						        "loop":true,
						        "colorType":"HSB"
						    }
						}';
		} else {
			$command = '{  
						    "write":{  
						        "command":"displayTemp",
						        "duration":'. $duration .',
						        "animType":"solid",
						        "palette":[  
						            '. $color .'
						        ],
						        "colorType":"HSB"
						    }
						}';
		}		

		$url = 'http://' . $ip . $api_url . $api_key . '/effects';
		callurl($url,$command);	
}

// execute command

function callurl($url,$command)
{
		$curl = curl_init ();
		curl_setopt ( $curl, CURLOPT_URL, $url );
		curl_setopt ( $curl, CURLOPT_SSL_VERIFYPEER, FALSE );
		curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'PUT');
		curl_setopt($curl, CURLOPT_POSTFIELDS, $command);
		curl_exec ( $curl );
		curl_close ( $curl );		
}

?>